/*
 * Project: SafeBee GPS Tracker
 * Author: Zak Kemble, contact@zakkemble.net
 * Copyright: (C) 2019 by Zak Kemble
 * License: 
 * Web: 
 */

#ifndef COMMON_H_
#define COMMON_H_

#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <ctype.h>

#include "config.h"

#include "stm32f0xx.h"
#include "stm32f0_xtra.h"

#include "tinyprintf.h"

#include "inc/debug.h"

#include "inc/typedefs.h"
#include "inc/util.h"
#include "inc/millis.h"

#include "inc/sleep.h"
#include "inc/uart.h"
#include "inc/uartsoft.h"
#include "inc/i2c.h"
#include "inc/adc.h"
#include "inc/rtc.h"

#include "inc/tracker.h"
#include "inc/gsm.h"
#include "inc/gps.h"
#include "inc/accel.h"
#include "inc/battery.h"
#include "inc/sms.h"
#include "inc/smsmgr.h"
#include "inc/eeprom_emu.h"
#include "inc/led.h"

#endif /* COMMON_H_ */
