/*
 * Project: SafeBee GPS Tracker
 * Author: Zak Kemble, contact@zakkemble.net
 * Copyright: (C) 2019 by Zak Kemble
 * License: 
 * Web: 
 */

#ifndef DEBUG_H_
#define DEBUG_H_

#define PRINTD(fmt, ...) \
            do { if (ENABLE_PRINTF_UART && DEBUG) printf("(%lu)(DBG)"fmt, millis(), ## __VA_ARGS__); } while (0)

#define SMS_DBG(fmt, ...) \
            do { if (ENABLE_PRINTF_UART && DEBUG && DEBUG_SMS) printf("(%lu)(SMS)"fmt, millis(), ## __VA_ARGS__); } while (0)

#define GSM_DBG(fmt, ...) \
            do { if (ENABLE_PRINTF_UART && DEBUG && DEBUG_GSM) printf("(%lu)(GSM)"fmt, millis(), ## __VA_ARGS__); } while (0)

#define GPS_DBG(fmt, ...) \
            do { if (ENABLE_PRINTF_UART && DEBUG && DEBUG_GPS) printf("(%lu)(GPS)"fmt, millis(), ## __VA_ARGS__); } while (0)

#define GPS_DBG_RAW(fmt, ...) \
            do { if (ENABLE_PRINTF_UART && DEBUG && DEBUG_GPS) printf(fmt, ## __VA_ARGS__); } while (0)

#define TRK_DBG(fmt, ...) \
            do { if (ENABLE_PRINTF_UART && DEBUG && DEBUG_TRK) printf("(%lu)(TRK)"fmt, millis(), ## __VA_ARGS__); } while (0)

#define MGR_DBG(fmt, ...) \
            do { if (ENABLE_PRINTF_UART && DEBUG && DEBUG_MGR) printf("(%lu)(MGR)"fmt, millis(), ## __VA_ARGS__); } while (0)

#endif /* DEBUG_H_ */
