/*
 * Project: SafeBee GPS Tracker
 * Author: Zak Kemble, contact@zakkemble.net
 * Copyright: (C) 2019 by Zak Kemble
 * License: 
 * Web: 
 */

#ifndef I2C_H_
#define I2C_H_

typedef enum{
	I2C_GPS_OFF = 0, // I2C disconnected, open-drain output LOW
	I2C_GPS_ON, // I2C disconnected, pull-up
	I2C_GPS_DATA // I2C connected, pull-up
} i2c_gps_t;

void i2c_init(void);
void i2c_gps(i2c_gps_t state);
uint8_t i2c_write(uint8_t address, void* data, uint8_t len, uint8_t doStop);
uint8_t i2c_read(uint8_t address, void* data, uint8_t len);

#endif /* I2C_H_ */
