/*
 * Project: SafeBee GPS Tracker
 * Author: Zak Kemble, contact@zakkemble.net
 * Copyright: (C) 2019 by Zak Kemble
 * License: 
 * Web: 
 */

#ifndef SMSMGR_H_
#define SMSMGR_H_

typedef enum{
	SMSMGRMSG_LOWBATT = 0,
	SMSMGRMSG_STOPPED = 1,
	SMSMGRMSG_STATUS = 2,
	SMSMGRMSG_TRACK = 3,
	SMSMGRMSG_CMDRESP = 4,
	SMSMGRMSG_STATUSMONTHLY = 5,
	SMSMGRMSG_COUNT // Must be last
} smsMgrMsg_t;

typedef enum{
	SMSSEND_IDLE = 0,
	SMSSEND_DO,
	SMSSEND_SENDING,
	SMSSEND_SENT,
	SMSSEND_DELAY
} smsSend_t;

typedef void (*smsmgrmake_callback_t)(sms_t* sms, phoneNumber_t** phone);
typedef void (*smsmgrcomplete_callback_t)(smsSendResult_t status);

void smsmgr_init(void);
void smsmgr_setup(smsMgrMsg_t smsMgrMsg, millis_t retryDelay, uint8_t maxRetries, smsmgrmake_callback_t makeMessage, smsmgrcomplete_callback_t onComplete);
void smsmgr_update(void);
uint8_t smsmgr_begin(smsMgrMsg_t smsMgrMsg);
void smsmgr_stop(smsMgrMsg_t smsMgrMsg);
smsSend_t smsmgr_status(smsMgrMsg_t smsMgrMsg);
uint8_t smsmgr_busy(void);

#endif /* SMSMGR_H_ */
