/*
 * Project: SafeBee GPS Tracker
 * Author: Zak Kemble, contact@zakkemble.net
 * Copyright: (C) 2019 by Zak Kemble
 * License: 
 * Web: 
 */

#include "inc/common.h"

#define TICKS_PER_SECOND	1000
#define TICK_INT_PRIORITY	((uint32_t)(1U<<__NVIC_PRIO_BITS) - 1U) // Lowest priority (should set higher if millis() is used in an interrupt)

static volatile millis_t milliseconds;

void millis_init()
{
	// Setup systick
	//SysTick->LOAD = SystemCoreClock / TICKS_PER_SECOND;
	//SysTick->VAL = 0; // Clear counter
	//SysTick->CTRL |= 0x04|0x02|0x01; // Set clock source to processor, enable interrupt and enable timer
	
	SysTick_Config(SystemCoreClock / TICKS_PER_SECOND);
	// NVIC_EnableIRQ(SysTick_IRQn); // TODO ????
}

millis_t millis_get()
{
	return milliseconds;
}

void SysTick_Handler(void)
{
	++milliseconds;
}

void delay(millis_t ms)
{
	millis_t start = millis();
	while(millis() - start <= ms); // TODO sleep?
}
