/*
 * Project: SafeBee GPS Tracker
 * Author: Zak Kemble, contact@zakkemble.net
 * Copyright: (C) 2019 by Zak Kemble
 * License: 
 * Web: 
 */

#include "inc/common.h"

uint8_t __attribute__((weak)) CB_SLEEP_OK(void)
{
	return 0;
}

void sleep_init()
{
	RCC->APB1ENR |= RCC_APB1ENR_PWREN;
	PWR->CR |= PWR_CR_LPDS; // Regulator in low power mode in sleep
	RCC->APB1ENR &= ~RCC_APB1ENR_PWREN;

	SCB->SCR |= SCB_SCR_SLEEPDEEP_Msk;
}

uint8_t sleep_now()
{
	uint8_t didSleep = 0;

	__disable_irq();
	if(CB_SLEEP_OK())
	{
		__WFI();
		didSleep = 1;
	}
	__enable_irq();

	return didSleep;
}
