/*
 * Project: 
 * Author: Zak Kemble, contact@zakkemble.net
 * Copyright: (C) 2019 by Zak Kemble
 * License: 
 * Web: 
 */

#ifndef STM32F0_XTRA_H_
#define STM32F0_XTRA_H_

#define ADC_CFGR1_RES_12BIT	(0)
#define ADC_CFGR1_RES_10BIT	(ADC_CFGR1_RES_0)
#define ADC_CFGR1_RES_8BIT	(ADC_CFGR1_RES_1)
#define ADC_CFGR1_RES_6BIT	(ADC_CFGR1_RES_1|ADC_CFGR1_RES_0)

#define ADC_CFGR2_CKMODE_ADCCLK	(0)
#define ADC_CFGR2_CKMODE_PCLK2	(ADC_CFGR2_CKMODE_0)
#define ADC_CFGR2_CKMODE_PCLK4	(ADC_CFGR2_CKMODE_1)

#define ADC_SMPR_SMP_1DOT5		(0)
#define ADC_SMPR_SMP_7DOT5		(ADC_SMPR_SMP_0)
#define ADC_SMPR_SMP_13DOT5		(ADC_SMPR_SMP_1)
#define ADC_SMPR_SMP_28DOT5		(ADC_SMPR_SMP_1|ADC_SMPR_SMP_0)
#define ADC_SMPR_SMP_41DOT5		(ADC_SMPR_SMP_2)
#define ADC_SMPR_SMP_55DOT5		(ADC_SMPR_SMP_2|ADC_SMPR_SMP_0)
#define ADC_SMPR_SMP_71DOT5		(ADC_SMPR_SMP_2|ADC_SMPR_SMP_1)
#define ADC_SMPR_SMP_239DOT5	(ADC_SMPR_SMP_2|ADC_SMPR_SMP_1|ADC_SMPR_SMP_0)

#define CONCAT2(a, b) a ## b
#define CONCAT3(a, b, c) a ## b ## c
#define CONCAT4(a, b, c, d) a ## b ## c ## d

#define GPIO0_MODE_MASK		(~(GPIO_MODER_MODER0_1 | GPIO_MODER_MODER0_0))
#define GPIO1_MODE_MASK		(~(GPIO_MODER_MODER1_1 | GPIO_MODER_MODER1_0))
#define GPIO2_MODE_MASK		(~(GPIO_MODER_MODER2_1 | GPIO_MODER_MODER2_0))
#define GPIO3_MODE_MASK		(~(GPIO_MODER_MODER3_1 | GPIO_MODER_MODER3_0))
#define GPIO4_MODE_MASK		(~(GPIO_MODER_MODER4_1 | GPIO_MODER_MODER4_0))
#define GPIO5_MODE_MASK		(~(GPIO_MODER_MODER5_1 | GPIO_MODER_MODER5_0))
#define GPIO6_MODE_MASK		(~(GPIO_MODER_MODER6_1 | GPIO_MODER_MODER6_0))
#define GPIO7_MODE_MASK		(~(GPIO_MODER_MODER7_1 | GPIO_MODER_MODER7_0))
#define GPIO8_MODE_MASK		(~(GPIO_MODER_MODER8_1 | GPIO_MODER_MODER8_0))
#define GPIO9_MODE_MASK		(~(GPIO_MODER_MODER9_1 | GPIO_MODER_MODER9_0))
#define GPIO10_MODE_MASK	(~(GPIO_MODER_MODER10_1 | GPIO_MODER_MODER10_0))
#define GPIO11_MODE_MASK	(~(GPIO_MODER_MODER11_1 | GPIO_MODER_MODER11_0))
#define GPIO12_MODE_MASK	(~(GPIO_MODER_MODER12_1 | GPIO_MODER_MODER12_0))
#define GPIO13_MODE_MASK	(~(GPIO_MODER_MODER13_1 | GPIO_MODER_MODER13_0))
#define GPIO14_MODE_MASK	(~(GPIO_MODER_MODER14_1 | GPIO_MODER_MODER14_0))
#define GPIO15_MODE_MASK	(~(GPIO_MODER_MODER15_1 | GPIO_MODER_MODER15_0))

#define GPIO0_MODE_ANALOG	(GPIO_MODER_MODER0_1 | GPIO_MODER_MODER0_0)
#define GPIO1_MODE_ANALOG	(GPIO_MODER_MODER1_1 | GPIO_MODER_MODER1_0)
#define GPIO2_MODE_ANALOG	(GPIO_MODER_MODER2_1 | GPIO_MODER_MODER2_0)
#define GPIO3_MODE_ANALOG	(GPIO_MODER_MODER3_1 | GPIO_MODER_MODER3_0)
#define GPIO4_MODE_ANALOG	(GPIO_MODER_MODER4_1 | GPIO_MODER_MODER4_0)
#define GPIO5_MODE_ANALOG	(GPIO_MODER_MODER5_1 | GPIO_MODER_MODER5_0)
#define GPIO6_MODE_ANALOG	(GPIO_MODER_MODER6_1 | GPIO_MODER_MODER6_0)
#define GPIO7_MODE_ANALOG	(GPIO_MODER_MODER7_1 | GPIO_MODER_MODER7_0)
#define GPIO8_MODE_ANALOG	(GPIO_MODER_MODER8_1 | GPIO_MODER_MODER8_0)
#define GPIO9_MODE_ANALOG	(GPIO_MODER_MODER9_1 | GPIO_MODER_MODER9_0)
#define GPIO10_MODE_ANALOG	(GPIO_MODER_MODER10_1 | GPIO_MODER_MODER10_0)
#define GPIO11_MODE_ANALOG	(GPIO_MODER_MODER11_1 | GPIO_MODER_MODER11_0)
#define GPIO12_MODE_ANALOG	(GPIO_MODER_MODER12_1 | GPIO_MODER_MODER12_0)
#define GPIO13_MODE_ANALOG	(GPIO_MODER_MODER13_1 | GPIO_MODER_MODER13_0)
#define GPIO14_MODE_ANALOG	(GPIO_MODER_MODER14_1 | GPIO_MODER_MODER14_0)
#define GPIO15_MODE_ANALOG	(GPIO_MODER_MODER15_1 | GPIO_MODER_MODER15_0)

#define GPIO0_MODE_INPUT	(0)
#define GPIO1_MODE_INPUT	(0)
#define GPIO2_MODE_INPUT	(0)
#define GPIO3_MODE_INPUT	(0)
#define GPIO4_MODE_INPUT	(0)
#define GPIO5_MODE_INPUT	(0)
#define GPIO6_MODE_INPUT	(0)
#define GPIO7_MODE_INPUT	(0)
#define GPIO8_MODE_INPUT	(0)
#define GPIO9_MODE_INPUT	(0)
#define GPIO10_MODE_INPUT	(0)
#define GPIO11_MODE_INPUT	(0)
#define GPIO12_MODE_INPUT	(0)
#define GPIO13_MODE_INPUT	(0)
#define GPIO14_MODE_INPUT	(0)
#define GPIO15_MODE_INPUT	(0)

#define GPIO0_MODE_OUTPUT	(GPIO_MODER_MODER0_0)
#define GPIO1_MODE_OUTPUT	(GPIO_MODER_MODER1_0)
#define GPIO2_MODE_OUTPUT	(GPIO_MODER_MODER2_0)
#define GPIO3_MODE_OUTPUT	(GPIO_MODER_MODER3_0)
#define GPIO4_MODE_OUTPUT	(GPIO_MODER_MODER4_0)
#define GPIO5_MODE_OUTPUT	(GPIO_MODER_MODER5_0)
#define GPIO6_MODE_OUTPUT	(GPIO_MODER_MODER6_0)
#define GPIO7_MODE_OUTPUT	(GPIO_MODER_MODER7_0)
#define GPIO8_MODE_OUTPUT	(GPIO_MODER_MODER8_0)
#define GPIO9_MODE_OUTPUT	(GPIO_MODER_MODER9_0)
#define GPIO10_MODE_OUTPUT	(GPIO_MODER_MODER10_0)
#define GPIO11_MODE_OUTPUT	(GPIO_MODER_MODER11_0)
#define GPIO12_MODE_OUTPUT	(GPIO_MODER_MODER12_0)
#define GPIO13_MODE_OUTPUT	(GPIO_MODER_MODER13_0)
#define GPIO14_MODE_OUTPUT	(GPIO_MODER_MODER14_0)
#define GPIO15_MODE_OUTPUT	(GPIO_MODER_MODER15_0)

#define GPIO0_MODE_ALT	(GPIO_MODER_MODER0_1)
#define GPIO1_MODE_ALT	(GPIO_MODER_MODER1_1)
#define GPIO2_MODE_ALT	(GPIO_MODER_MODER2_1)
#define GPIO3_MODE_ALT	(GPIO_MODER_MODER3_1)
#define GPIO4_MODE_ALT	(GPIO_MODER_MODER4_1)
#define GPIO5_MODE_ALT	(GPIO_MODER_MODER5_1)
#define GPIO6_MODE_ALT	(GPIO_MODER_MODER6_1)
#define GPIO7_MODE_ALT	(GPIO_MODER_MODER7_1)
#define GPIO8_MODE_ALT	(GPIO_MODER_MODER8_1)
#define GPIO9_MODE_ALT	(GPIO_MODER_MODER9_1)
#define GPIO10_MODE_ALT	(GPIO_MODER_MODER10_1)
#define GPIO11_MODE_ALT	(GPIO_MODER_MODER11_1)
#define GPIO12_MODE_ALT	(GPIO_MODER_MODER12_1)
#define GPIO13_MODE_ALT	(GPIO_MODER_MODER13_1)
#define GPIO14_MODE_ALT	(GPIO_MODER_MODER14_1)
#define GPIO15_MODE_ALT	(GPIO_MODER_MODER15_1)

#define GPIO_MODE(pin, set)				CONCAT4(GPIO, pin, _MODE_, set)
#define GPIO_MODE_REG					MODER
#define GPIO_SET_MODE(port, pin, set)	CONCAT2(GPIO, port)->GPIO_MODE_REG = (CONCAT2(GPIO, port)->GPIO_MODE_REG & GPIO_MODE(pin, MASK)) | GPIO_MODE(pin, set)




#define GPIO0_OTYPE_MASK	(~(GPIO_OTYPER_OT_0))
#define GPIO1_OTYPE_MASK	(~(GPIO_OTYPER_OT_1))
#define GPIO2_OTYPE_MASK	(~(GPIO_OTYPER_OT_2))
#define GPIO3_OTYPE_MASK	(~(GPIO_OTYPER_OT_3))
#define GPIO4_OTYPE_MASK	(~(GPIO_OTYPER_OT_4))
#define GPIO5_OTYPE_MASK	(~(GPIO_OTYPER_OT_5))
#define GPIO6_OTYPE_MASK	(~(GPIO_OTYPER_OT_6))
#define GPIO7_OTYPE_MASK	(~(GPIO_OTYPER_OT_7))
#define GPIO8_OTYPE_MASK	(~(GPIO_OTYPER_OT_8))
#define GPIO9_OTYPE_MASK	(~(GPIO_OTYPER_OT_9))
#define GPIO10_OTYPE_MASK	(~(GPIO_OTYPER_OT_10))
#define GPIO11_OTYPE_MASK	(~(GPIO_OTYPER_OT_11))
#define GPIO12_OTYPE_MASK	(~(GPIO_OTYPER_OT_12))
#define GPIO13_OTYPE_MASK	(~(GPIO_OTYPER_OT_13))
#define GPIO14_OTYPE_MASK	(~(GPIO_OTYPER_OT_14))
#define GPIO15_OTYPE_MASK	(~(GPIO_OTYPER_OT_15))

#define GPIO0_OTYPE_OD	(GPIO_OTYPER_OT_0)
#define GPIO1_OTYPE_OD	(GPIO_OTYPER_OT_1)
#define GPIO2_OTYPE_OD	(GPIO_OTYPER_OT_2)
#define GPIO3_OTYPE_OD	(GPIO_OTYPER_OT_3)
#define GPIO4_OTYPE_OD	(GPIO_OTYPER_OT_4)
#define GPIO5_OTYPE_OD	(GPIO_OTYPER_OT_5)
#define GPIO6_OTYPE_OD	(GPIO_OTYPER_OT_6)
#define GPIO7_OTYPE_OD	(GPIO_OTYPER_OT_7)
#define GPIO8_OTYPE_OD	(GPIO_OTYPER_OT_8)
#define GPIO9_OTYPE_OD	(GPIO_OTYPER_OT_9)
#define GPIO10_OTYPE_OD	(GPIO_OTYPER_OT_10)
#define GPIO11_OTYPE_OD	(GPIO_OTYPER_OT_11)
#define GPIO12_OTYPE_OD	(GPIO_OTYPER_OT_12)
#define GPIO13_OTYPE_OD	(GPIO_OTYPER_OT_13)
#define GPIO14_OTYPE_OD	(GPIO_OTYPER_OT_14)
#define GPIO15_OTYPE_OD	(GPIO_OTYPER_OT_15)

#define GPIO0_OTYPE_PP	(0)
#define GPIO1_OTYPE_PP	(0)
#define GPIO2_OTYPE_PP	(0)
#define GPIO3_OTYPE_PP	(0)
#define GPIO4_OTYPE_PP	(0)
#define GPIO5_OTYPE_PP	(0)
#define GPIO6_OTYPE_PP	(0)
#define GPIO7_OTYPE_PP	(0)
#define GPIO8_OTYPE_PP	(0)
#define GPIO9_OTYPE_PP	(0)
#define GPIO10_OTYPE_PP	(0)
#define GPIO11_OTYPE_PP	(0)
#define GPIO12_OTYPE_PP	(0)
#define GPIO13_OTYPE_PP	(0)
#define GPIO14_OTYPE_PP	(0)
#define GPIO15_OTYPE_PP	(0)

#define GPIO_OTYPE(pin, set) CONCAT4(GPIO, pin, _OTYPE_, set)
#define GPIO_SET_OTYPE(port, pin, set) CONCAT2(GPIO, port)->OTYPER = (CONCAT2(GPIO, port)->OTYPER & CONCAT4(GPIO, pin, _OTYPE_, MASK)) | CONCAT4(GPIO, pin, _OTYPE_, set)




#define GPIO0_PUPD_MASK		(~(GPIO_PUPDR_PUPDR0_1 | GPIO_PUPDR_PUPDR0_0))
#define GPIO1_PUPD_MASK		(~(GPIO_PUPDR_PUPDR1_1 | GPIO_PUPDR_PUPDR1_0))
#define GPIO2_PUPD_MASK		(~(GPIO_PUPDR_PUPDR2_1 | GPIO_PUPDR_PUPDR2_0))
#define GPIO3_PUPD_MASK		(~(GPIO_PUPDR_PUPDR3_1 | GPIO_PUPDR_PUPDR3_0))
#define GPIO4_PUPD_MASK		(~(GPIO_PUPDR_PUPDR4_1 | GPIO_PUPDR_PUPDR4_0))
#define GPIO5_PUPD_MASK		(~(GPIO_PUPDR_PUPDR5_1 | GPIO_PUPDR_PUPDR5_0))
#define GPIO6_PUPD_MASK		(~(GPIO_PUPDR_PUPDR6_1 | GPIO_PUPDR_PUPDR6_0))
#define GPIO7_PUPD_MASK		(~(GPIO_PUPDR_PUPDR7_1 | GPIO_PUPDR_PUPDR7_0))
#define GPIO8_PUPD_MASK		(~(GPIO_PUPDR_PUPDR8_1 | GPIO_PUPDR_PUPDR8_0))
#define GPIO9_PUPD_MASK		(~(GPIO_PUPDR_PUPDR9_1 | GPIO_PUPDR_PUPDR9_0))
#define GPIO10_PUPD_MASK	(~(GPIO_PUPDR_PUPDR10_1 | GPIO_PUPDR_PUPDR10_0))
#define GPIO11_PUPD_MASK	(~(GPIO_PUPDR_PUPDR11_1 | GPIO_PUPDR_PUPDR11_0))
#define GPIO12_PUPD_MASK	(~(GPIO_PUPDR_PUPDR12_1 | GPIO_PUPDR_PUPDR12_0))
#define GPIO13_PUPD_MASK	(~(GPIO_PUPDR_PUPDR13_1 | GPIO_PUPDR_PUPDR13_0))
#define GPIO14_PUPD_MASK	(~(GPIO_PUPDR_PUPDR14_1 | GPIO_PUPDR_PUPDR14_0))
#define GPIO15_PUPD_MASK	(~(GPIO_PUPDR_PUPDR15_1 | GPIO_PUPDR_PUPDR15_0))

#define GPIO0_PUPD_NONE	(0)
#define GPIO1_PUPD_NONE	(0)
#define GPIO2_PUPD_NONE	(0)
#define GPIO3_PUPD_NONE	(0)
#define GPIO4_PUPD_NONE	(0)
#define GPIO5_PUPD_NONE	(0)
#define GPIO6_PUPD_NONE	(0)
#define GPIO7_PUPD_NONE	(0)
#define GPIO8_PUPD_NONE	(0)
#define GPIO9_PUPD_NONE	(0)
#define GPIO10_PUPD_NONE	(0)
#define GPIO11_PUPD_NONE	(0)
#define GPIO12_PUPD_NONE	(0)
#define GPIO13_PUPD_NONE	(0)
#define GPIO14_PUPD_NONE	(0)
#define GPIO15_PUPD_NONE	(0)

#define GPIO0_PUPD_UP	(GPIO_PUPDR_PUPDR0_0)
#define GPIO1_PUPD_UP	(GPIO_PUPDR_PUPDR1_0)
#define GPIO2_PUPD_UP	(GPIO_PUPDR_PUPDR2_0)
#define GPIO3_PUPD_UP	(GPIO_PUPDR_PUPDR3_0)
#define GPIO4_PUPD_UP	(GPIO_PUPDR_PUPDR4_0)
#define GPIO5_PUPD_UP	(GPIO_PUPDR_PUPDR5_0)
#define GPIO6_PUPD_UP	(GPIO_PUPDR_PUPDR6_0)
#define GPIO7_PUPD_UP	(GPIO_PUPDR_PUPDR7_0)
#define GPIO8_PUPD_UP	(GPIO_PUPDR_PUPDR8_0)
#define GPIO9_PUPD_UP	(GPIO_PUPDR_PUPDR9_0)
#define GPIO10_PUPD_UP	(GPIO_PUPDR_PUPDR10_0)
#define GPIO11_PUPD_UP	(GPIO_PUPDR_PUPDR11_0)
#define GPIO12_PUPD_UP	(GPIO_PUPDR_PUPDR12_0)
#define GPIO13_PUPD_UP	(GPIO_PUPDR_PUPDR13_0)
#define GPIO14_PUPD_UP	(GPIO_PUPDR_PUPDR14_0)
#define GPIO15_PUPD_UP	(GPIO_PUPDR_PUPDR15_0)

#define GPIO0_PUPD_DOWN		(GPIO_PUPDR_PUPDR0_1)
#define GPIO1_PUPD_DOWN		(GPIO_PUPDR_PUPDR1_1)
#define GPIO2_PUPD_DOWN		(GPIO_PUPDR_PUPDR2_1)
#define GPIO3_PUPD_DOWN		(GPIO_PUPDR_PUPDR3_1)
#define GPIO4_PUPD_DOWN		(GPIO_PUPDR_PUPDR4_1)
#define GPIO5_PUPD_DOWN		(GPIO_PUPDR_PUPDR5_1)
#define GPIO6_PUPD_DOWN		(GPIO_PUPDR_PUPDR6_1)
#define GPIO7_PUPD_DOWN		(GPIO_PUPDR_PUPDR7_1)
#define GPIO8_PUPD_DOWN		(GPIO_PUPDR_PUPDR8_1)
#define GPIO9_PUPD_DOWN		(GPIO_PUPDR_PUPDR9_1)
#define GPIO10_PUPD_DOWN	(GPIO_PUPDR_PUPDR10_1)
#define GPIO11_PUPD_DOWN	(GPIO_PUPDR_PUPDR11_1)
#define GPIO12_PUPD_DOWN	(GPIO_PUPDR_PUPDR12_1)
#define GPIO13_PUPD_DOWN	(GPIO_PUPDR_PUPDR13_1)
#define GPIO14_PUPD_DOWN	(GPIO_PUPDR_PUPDR14_1)
#define GPIO15_PUPD_DOWN	(GPIO_PUPDR_PUPDR15_1)

#define GPIO_PUPD(pin, set)				CONCAT4(GPIO, pin, _PUPD_, set)
#define GPIO_PUPD_REG					PUPDR
#define GPIO_SET_PUPD(port, pin, set)	CONCAT2(GPIO, port)->GPIO_PUPD_REG = (CONCAT2(GPIO, port)->GPIO_PUPD_REG & GPIO_PUPD(pin, MASK)) | GPIO_PUPD(pin, set)



// GPIO Speed
#define GPIO0_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR0_1 | GPIO_OSPEEDR_OSPEEDR0_0))
#define GPIO1_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR1_1 | GPIO_OSPEEDR_OSPEEDR1_0))
#define GPIO2_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR2_1 | GPIO_OSPEEDR_OSPEEDR2_0))
#define GPIO3_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR3_1 | GPIO_OSPEEDR_OSPEEDR3_0))
#define GPIO4_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR4_1 | GPIO_OSPEEDR_OSPEEDR4_0))
#define GPIO5_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR5_1 | GPIO_OSPEEDR_OSPEEDR5_0))
#define GPIO6_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR6_1 | GPIO_OSPEEDR_OSPEEDR6_0))
#define GPIO7_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR7_1 | GPIO_OSPEEDR_OSPEEDR7_0))
#define GPIO8_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR8_1 | GPIO_OSPEEDR_OSPEEDR8_0))
#define GPIO9_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR9_1 | GPIO_OSPEEDR_OSPEEDR9_0))
#define GPIO10_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR10_1 | GPIO_OSPEEDR_OSPEEDR10_0))
#define GPIO11_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR11_1 | GPIO_OSPEEDR_OSPEEDR11_0))
#define GPIO12_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR12_1 | GPIO_OSPEEDR_OSPEEDR12_0))
#define GPIO13_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR13_1 | GPIO_OSPEEDR_OSPEEDR13_0))
#define GPIO14_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR14_1 | GPIO_OSPEEDR_OSPEEDR14_0))
#define GPIO15_SPEED_MASK	(~(GPIO_OSPEEDR_OSPEEDR15_1 | GPIO_OSPEEDR_OSPEEDR15_0))

#define GPIO0_SPEED_LOW	(0)
#define GPIO1_SPEED_LOW	(0)
#define GPIO2_SPEED_LOW	(0)
#define GPIO3_SPEED_LOW	(0)
#define GPIO4_SPEED_LOW	(0)
#define GPIO5_SPEED_LOW	(0)
#define GPIO6_SPEED_LOW	(0)
#define GPIO7_SPEED_LOW	(0)
#define GPIO8_SPEED_LOW	(0)
#define GPIO9_SPEED_LOW	(0)
#define GPIO10_SPEED_LOW	(0)
#define GPIO11_SPEED_LOW	(0)
#define GPIO12_SPEED_LOW	(0)
#define GPIO13_SPEED_LOW	(0)
#define GPIO14_SPEED_LOW	(0)
#define GPIO15_SPEED_LOW	(0)

#define GPIO0_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR0_0)
#define GPIO1_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR1_0)
#define GPIO2_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR2_0)
#define GPIO3_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR3_0)
#define GPIO4_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR4_0)
#define GPIO5_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR5_0)
#define GPIO6_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR6_0)
#define GPIO7_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR7_0)
#define GPIO8_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR8_0)
#define GPIO9_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR9_0)
#define GPIO10_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR10_0)
#define GPIO11_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR11_0)
#define GPIO12_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR12_0)
#define GPIO13_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR13_0)
#define GPIO14_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR14_0)
#define GPIO15_SPEED_MEDIUM	(GPIO_OSPEEDR_OSPEEDR15_0)

#define GPIO0_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR0_1 | GPIO_OSPEEDR_OSPEEDR0_0)
#define GPIO1_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR1_1 | GPIO_OSPEEDR_OSPEEDR1_0)
#define GPIO2_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR2_1 | GPIO_OSPEEDR_OSPEEDR2_0)
#define GPIO3_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR3_1 | GPIO_OSPEEDR_OSPEEDR3_0)
#define GPIO4_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR4_1 | GPIO_OSPEEDR_OSPEEDR4_0)
#define GPIO5_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR5_1 | GPIO_OSPEEDR_OSPEEDR5_0)
#define GPIO6_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR6_1 | GPIO_OSPEEDR_OSPEEDR6_0)
#define GPIO7_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR7_1 | GPIO_OSPEEDR_OSPEEDR7_0)
#define GPIO8_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR8_1 | GPIO_OSPEEDR_OSPEEDR8_0)
#define GPIO9_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR9_1 | GPIO_OSPEEDR_OSPEEDR9_0)
#define GPIO10_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR10_1 | GPIO_OSPEEDR_OSPEEDR10_0)
#define GPIO11_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR11_1 | GPIO_OSPEEDR_OSPEEDR11_0)
#define GPIO12_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR12_1 | GPIO_OSPEEDR_OSPEEDR12_0)
#define GPIO13_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR13_1 | GPIO_OSPEEDR_OSPEEDR13_0)
#define GPIO14_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR14_1 | GPIO_OSPEEDR_OSPEEDR14_0)
#define GPIO15_SPEED_HIGH	(GPIO_OSPEEDR_OSPEEDR15_1 | GPIO_OSPEEDR_OSPEEDR15_0)

#define GPIO_SPEED(pin, set) CONCAT4(GPIO, pin, _SPEED_, set)
#define GPIO_SET_SPEED(port, pin, set) CONCAT2(GPIO, port)->SPEEDR = (CONCAT2(GPIO, port)->SPEEDR & CONCAT4(GPIO, pin, _SPEED_, MASK)) | CONCAT4(GPIO, pin, _SPEED_, set)



#define GPIO0_AF_0	(0<<GPIO_AFRL_AFSEL0_Pos)
#define GPIO0_AF_1	(1<<GPIO_AFRL_AFSEL0_Pos)
#define GPIO0_AF_2	(2<<GPIO_AFRL_AFSEL0_Pos)
#define GPIO0_AF_3	(3<<GPIO_AFRL_AFSEL0_Pos)
#define GPIO0_AF_4	(4<<GPIO_AFRL_AFSEL0_Pos)
#define GPIO0_AF_5	(5<<GPIO_AFRL_AFSEL0_Pos)
#define GPIO0_AF_6	(6<<GPIO_AFRL_AFSEL0_Pos)

#define GPIO9_AF_0	(0<<GPIO_AFRH_AFSEL9_Pos)
#define GPIO9_AF_1	(1<<GPIO_AFRH_AFSEL9_Pos)
#define GPIO9_AF_2	(2<<GPIO_AFRH_AFSEL9_Pos)
#define GPIO9_AF_3	(3<<GPIO_AFRH_AFSEL9_Pos)
#define GPIO9_AF_4	(4<<GPIO_AFRH_AFSEL9_Pos)
#define GPIO9_AF_5	(5<<GPIO_AFRH_AFSEL9_Pos)
#define GPIO9_AF_6	(6<<GPIO_AFRH_AFSEL9_Pos)

#define GPIO10_AF_0	(0<<GPIO_AFRH_AFSEL10_Pos)
#define GPIO10_AF_1	(1<<GPIO_AFRH_AFSEL10_Pos)
#define GPIO10_AF_2	(2<<GPIO_AFRH_AFSEL10_Pos)
#define GPIO10_AF_3	(3<<GPIO_AFRH_AFSEL10_Pos)
#define GPIO10_AF_4	(4<<GPIO_AFRH_AFSEL10_Pos)
#define GPIO10_AF_5	(5<<GPIO_AFRH_AFSEL10_Pos)
#define GPIO10_AF_6	(6<<GPIO_AFRH_AFSEL10_Pos)

#define GPIO14_AF_0	(0<<GPIO_AFRH_AFSEL14_Pos)
#define GPIO14_AF_1	(1<<GPIO_AFRH_AFSEL14_Pos)
#define GPIO14_AF_2	(2<<GPIO_AFRH_AFSEL14_Pos)
#define GPIO14_AF_3	(3<<GPIO_AFRH_AFSEL14_Pos)
#define GPIO14_AF_4	(4<<GPIO_AFRH_AFSEL14_Pos)
#define GPIO14_AF_5	(5<<GPIO_AFRH_AFSEL14_Pos)
#define GPIO14_AF_6	(6<<GPIO_AFRH_AFSEL14_Pos)

#define GPIO_AFL(pin, set) (set<<CONCAT3(GPIO_AFRL_AFSEL, pin, _Pos))
#define GPIO_AFH(pin, set) (set<<CONCAT3(GPIO_AFRH_AFSEL, pin, _Pos))
#define GPIO_AFL_MSK(pin) (CONCAT3(GPIO_AFRL_AFSEL, pin, _Msk))
#define GPIO_AFH_MSK(pin) (CONCAT3(GPIO_AFRH_AFSEL, pin, _Msk))



#define GPIO0_OUT_MASK	(~(GPIO_ODR_0))
#define GPIO1_OUT_MASK	(~(GPIO_ODR_1))
#define GPIO2_OUT_MASK	(~(GPIO_ODR_2))
#define GPIO3_OUT_MASK	(~(GPIO_ODR_3))
#define GPIO4_OUT_MASK	(~(GPIO_ODR_4))
#define GPIO5_OUT_MASK	(~(GPIO_ODR_5))
#define GPIO6_OUT_MASK	(~(GPIO_ODR_6))
#define GPIO7_OUT_MASK	(~(GPIO_ODR_7))
#define GPIO8_OUT_MASK	(~(GPIO_ODR_8))
#define GPIO9_OUT_MASK	(~(GPIO_ODR_9))
#define GPIO10_OUT_MASK	(~(GPIO_ODR_10))
#define GPIO11_OUT_MASK	(~(GPIO_ODR_11))
#define GPIO12_OUT_MASK	(~(GPIO_ODR_12))
#define GPIO13_OUT_MASK	(~(GPIO_ODR_13))
#define GPIO14_OUT_MASK	(~(GPIO_ODR_14))
#define GPIO15_OUT_MASK	(~(GPIO_ODR_15))

#define GPIO0_OUT_HIGH	(GPIO_ODR_0)
#define GPIO1_OUT_HIGH	(GPIO_ODR_1)
#define GPIO2_OUT_HIGH	(GPIO_ODR_2)
#define GPIO4_OUT_HIGH	(GPIO_ODR_4)
#define GPIO5_OUT_HIGH	(GPIO_ODR_5)
#define GPIO6_OUT_HIGH	(GPIO_ODR_6)
#define GPIO7_OUT_HIGH	(GPIO_ODR_7)
#define GPIO8_OUT_HIGH	(GPIO_ODR_8)
#define GPIO9_OUT_HIGH	(GPIO_ODR_9)
#define GPIO10_OUT_HIGH	(GPIO_ODR_10)
#define GPIO11_OUT_HIGH	(GPIO_ODR_11)
#define GPIO12_OUT_HIGH	(GPIO_ODR_12)
#define GPIO13_OUT_HIGH	(GPIO_ODR_13)
#define GPIO14_OUT_HIGH	(GPIO_ODR_14)
#define GPIO15_OUT_HIGH	(GPIO_ODR_15)

#define GPIO0_OUT_LOW	(0)
#define GPIO1_OUT_LOW	(0)
#define GPIO2_OUT_LOW	(0)
#define GPIO3_OUT_LOW	(0)
#define GPIO4_OUT_LOW	(0)
#define GPIO5_OUT_LOW	(0)
#define GPIO6_OUT_LOW	(0)
#define GPIO7_OUT_LOW	(0)
#define GPIO8_OUT_LOW	(0)
#define GPIO9_OUT_LOW	(0)
#define GPIO10_OUT_LOW	(0)
#define GPIO11_OUT_LOW	(0)
#define GPIO12_OUT_LOW	(0)
#define GPIO13_OUT_LOW	(0)
#define GPIO14_OUT_LOW	(0)
#define GPIO15_OUT_LOW	(0)

#define GPIO_OUT(pin, set)				CONCAT4(GPIO, pin, _OUT_, set)
#define GPIO_OUT_REG					ODR
#define GPIO_SET_OUT(port, pin, set)	CONCAT2(GPIO, port)->GPIO_OUT_REG = (CONCAT2(GPIO, port)->GPIO_OUT_REG & GPIO_OUT(pin, MASK)) | GPIO_OUT(pin, set)

#endif /* STM32F0_XTRA_H_ */
